/*
 * Uchwyt to RPi oraz klawisze pauzy
 * do Anet A8
 * Copyright: Bohdan R. Rau <ethanak@polip.com>
 * Licencja: MIT
 */
 
piw = 85;
pid = 56;
phdx = 58;
phd = 3.5;
eta = 1;
wall = 2;
dwall = 1.7;
$fn=32;
piwin = piw + 2 * eta;
pidin = pid + 2 * eta;

module cyls(d,t,h,d2=0) {
    de = d2?d2:d;
    for (x = [phd, phd + phdx]) {
        for (y = [phd, pid-phd]) {
            translate([x,y,t]) cylinder(d1=d, d2=de,h=h);
        }
    }
}

module base()
{
    dba = 9;
    difference() {
        union() {
            cyls(5,0,5,5);
            difference() {
                translate([-eta-wall, -eta-wall, 0]) cube([piwin+2*wall,pidin+2*wall, 5]);
                 translate([-eta, -eta, dwall]) cube([piwin,pidin, 5]);    
                translate([-eta + dba, -eta + dba, -1]) cube([piwin-2*dba, pidin-2*dba,10]);
            }
        }
        cyls(2.5,-1,7);
        cyls(4.5,-0.01,1, 2.5);
        translate([-5,pidin/2-10,2.3]) cube([10,20,10]);
    }
}

dsphow = 153;
dsphoh = 51;
dspdh = 10;

module displej()
{
    hds = dsphoh + 5 + 5;
    wds = dsphow + 10;
    
    difference() {
        translate([-5,-5,0]) cube([wds, hds, dwall]);
        translate([5,5,-1]) cube([wds-20, hds-25,10]);
        translate([8.1,dsphoh,-1]) cube([piwin-1,10,10]);
        translate([8.1,2,-1]) cube([piwin-1,5,10]);

        for (x=[0,dsphow, dsphow-54]) for (y=[0,dsphoh]) translate([x,y,-1]) {
            if (x !=dsphow) {
                cylinder(d=3.5,h=10);
            } else {
                hull() {
                    translate([-1,0,0]) cylinder(d=3.5,h=10);
                    translate([1,0,0]) cylinder(d=3.5,h=10);
                }
            }
        }
        for (y=[0,dsphoh]) translate([dsphow-54,y,-0.01]) {
            cylinder(d1=6.5, d2=3.5,h=1.5);
        }
            
    }
      translate([6.5,1,0]) base();
       
}

module podkladki()
{
    for (x=[0,10,20,30,40]) translate([x,0,0]) difference() {
        cylinder(d=8,h=2,center=true);
        cylinder(d=3.5,h=4,center=true);
    }
}

module podkladka()
{
    difference() {
        cylinder(d=8,h=2,center=true);
        cylinder(d=3.5,h=4,center=true);
    }
}



module upholder()
{
    module cyl2(t=0)
    {
        zh = t ? 0 : 1;
        de = t ? upr : 3.5;
        ha = upz + 2 * zh;
        for (x=[0,dsphow]) {
            translate([x,0,-zh]) {
                if (x > 0) {
                    cylinder(d=de, h=ha);
                }
                else hull() {
                    translate([-0.75,0,0]) cylinder(d=de, h=ha);
                    translate([0.75,0,0]) cylinder(d=de, h=ha);
                }
            }
        }
    }
    
    difference() {
        union() {
            cyl2(1);
            for (x = [0,dsphow]) {
                translate([x-upr/2,0,0]) cube([upr,12,upz]);
            }
        }
        cyl2(0);
    }
}

module updistan(mid=0) {
    zz=5;
    trigle = [
            [10,0],
            [0,0],
            [0,-15],
            [-7,-15],
            [-7,-zz],
            [-15,-zz],
            [-15,37.5],
            [-10,40]
            ];
    
    lena = sqrt(20 * 20 + 40 * 40);
    echo(lena);
    alfa = asin(20/lena);
    echo(alfa);
    difference() {   
        linear_extrude(8,convexity=10) polygon(trigle, convexity=10);
        hull() {
        for (y=[-11,-9]) translate([-9,y,4]) rotate([0,90,0]) cylinder(d=3.5, h=10);
        }
        translate([10,0,4]) rotate([0,0,alfa]) {
            translate([0,10,0]) rotate([0,90,0]) cylinder(d=1.85, h=20, center=true);
            translate([0,30,0]) rotate([0,90,0]) cylinder(d=1.85, h=20, center=true);
            
        }
        if (mid) translate([-20,-20,-1])  cube([25, 20-zz-1,20]);
    }
    
}

swdist = 22.5;
swsize = 13.5;
swpop = 7;
module symetric(n=0)
{
    for (symetri3s = [0,1]) mirror([
        (n==0) ? symetri3s : 0,
        (n==1) ? symetri3s : 0,
        (n==2) ? symetri3s : 0]) children();
}

module klawisz(isdif = 0)
{
    if (!isdif) {
        symetric(1) translate([0,-swdist/2,0]) cylinder(d=4.1, h=swpop);
    }
    else {
        symetric(1) {
            translate([0,-swdist/2,-1]) cylinder(d=2.5, h=swpop+2);
            translate([0,-swdist/2,-0.01]) cylinder(d1=4.5,d2=2.5, h=1);
        }
        translate([-swsize/2, -swsize/2, -1]) cube([swsize, swsize, swpop]);
    }
}

fronth = 45;
frontholes = [10,30];
minifront = 60;
frontwall =1.9;
fronthkey = 20;
minikeydist = 25;
module minifront()
{
    difference() {
       union() { 
        translate([-minifront/2,0,0]) cube([minifront, fronth,frontwall]);
           symetric() translate([-minikeydist/2,fronthkey,0]) klawisz(0);
       }
           symetric() translate([-minikeydist/2,fronthkey,0]) klawisz(1);
       symetric() {
           for (y = frontholes) translate([-minifront/2 + 4,y,-1]) cylinder(d=2.5, h=10);
           }
       translate([0,fronthkey,-1]) cylinder(d=3,h=10);
           translate([0,fronthkey+5,-1]) cylinder(d=3,h=10);
           translate([0,fronthkey-5,-1]) cylinder(d=3,h=10);
   }
}


module widok()
{
    translate([8,0,0]) rotate([90,0,-90]) updistan(1);
    translate([minifront,0,0])rotate([90,0,-90]) updistan(0);
    translate([minifront/2,-15,0]) rotate([90+asin(20/45),0,180])minifront();
}

displej();    // mocowanie RPi
//minifront(); // panel przycisków
//updistan(1); // lewy wspornik
//updistan(0); // prawy wspornik
//podkladki(); // pięć podkładek
//widok();    // panel wraz ze wspornikami
//base();      // podstawka por RPi (jakby komuś była potrzebna)